/*******************************************************************************
 * Copyright (c) 2025, Jan Koester jan.koester@gmx.net
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 * Neither the name of the <organization> nor the
 *      names of its contributors may be used to endorse or promote products
 *      derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *******************************************************************************/

#include <chrono>
#include <vector>
#include <unordered_map>
#include <uuidp.h>

#include "authdb.h"
#include "hash.h"

#pragma once

#ifdef Windows
#define VISIBILITY __declspec(dllexport)
#else
#define VISIBILITY __attribute__((visibility("default")))
#endif

namespace authdb {
    
    class AuthData;

    class VISIBILITY ClientData : public AuthData {
    public:
        ClientData(uuid::uuid clid);
        ~ClientData();

        void setName(const char* name);
        const char *getName();

        void setKey(const char *key);
        const char *getKey();

        void setKrbKey(const std::string &src);
        const std::string getKrbKey();
    private:
        AuthData::Record *ClientName;
        AuthData::Record *ClientKey;
        AuthData::Record *ClientKrbKey;
        friend class Client;
    };

    class ClientConnections {
    public:
        ClientConnections(uuid::uuid sid,AuthBackend &bck,const class ClientData &clt);
        ClientConnections *next();

        AuthBackend *getBackend();

        const uuid::uuid getId();

        bool operator==(uuid::uuid sessid);
    private:
        ClientConnections  *_next;
        AuthBackend         _backend;
        uuid::uuid          _sessionId;
        class ClientData    _Data;
        std::chrono::steady_clock::time_point _created;
        friend class Client;
    };

    class Client {
    public:
        Client();
        Client(const Client &src);
        Client(Client &&src);
        ~Client();
        void create(AuthBackend &backend,class ClientData *data);
        void edit(AuthBackend &backend, class ClientData &dat);
        void remove(AuthBackend &backend,const uuid::uuid &clid);
        bool exits(AuthBackend&  backend,const uuid::uuid &clid, const char* name,int &ret);
        void info(AuthBackend   &backend,class ClientData &dat,size_t &pos);
        void list(AuthBackend &backend,std::vector<uuid::uuid> &uuids);

        ClientConnections *addConnection(AuthBackend &backend,const class ClientData &data);
        void delConnection(const uuid::uuid &conid);
        void cleanupExpiredConnections();

        bool checkConnection(const uuid::uuid &conid) const;
        ClientConnections *findConnection(const uuid::uuid &conid);

        ClientConnections *ConnectionData();

    private:
        ClientConnections *_firstConnection;
        ClientConnections *_lastConnection;
        std::unordered_map<uuid::uuid, ClientConnections*> _connectionIndex;
    };
};
